SystemOrganization addCategory: #BrokenClasses!

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/14/2013 14:47'!
+ aTrait
	"Creates a composition with the receiver and aTrait"
	aTrait traitsDo:[:t| self == t ifTrue:[TraitCompositionException
			signal: 'Trait ' , self asString, ' already in composition']].
	^TraitComposition withAll: {self}, aTrait asTraitComposition! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/14/2013 14:47'!
- anArrayOfSelectors
	"Creates an exclusion"
	^TraitExclusion
		with: self
		exclusions: anArrayOfSelectors! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/14/2013 14:46'!
@ anArrayOfAssociations 
	"Creates an alias"
	^TraitAlias with: self aliases: anArrayOfAssociations! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/14/2013 16:30'!
addSelectorSilently: selector withMethod: compiledMethod
	super addSelectorSilently: selector withMethod: compiledMethod.
	self instanceSide noteAddedSelector: selector meta: self isMeta.
	"updateTraits of users"
	self users do: [:each | each updateTraits ]! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/14/2013 15:03'!
addTraitUser: aTrait
	self users: (self users copyWith: aTrait)
! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/14/2013 13:34'!
asTraitComposition
	^TraitComposition with: self! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/14/2013 15:44'!
browserIcon
	"Answer an icon to be show in the browser for the receiving class."

	^ self traitComposition isEmpty ifTrue: [^#blank] ifFalse: [^#announcement]! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/14/2013 14:31'!
classTrait

	^ ClassTrait for: self! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/14/2013 14:40'!
copyTraitExpression

	^ self! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/14/2013 16:26'!
installTraitsFrom: aTraitComposition
	"Install the traits from the given composition. This method implements
	the core composition method - all others are just optimizations for
	particular cases. Consequently, the optimized versions can always fall
	back to this method when things get too hairy."
	| allTraits methods |

	(self traitComposition isEmpty and: [aTraitComposition isEmpty]) ifTrue: [^self].

	"Check for cycles"
	allTraits := aTraitComposition gather: [:t | t allTraits copyWith: t].
	(allTraits includes: self) ifTrue:[^self error: 'Cyclic trait definition detected'].

	self traitComposition: aTraitComposition.
	methods := self assembleTraitMethodsFrom: aTraitComposition.
	self installTraitMethodDict: methods.
	self isMeta ifFalse:[self classSide updateTraitsFrom: aTraitComposition].
	
	"updateTraits of users"
	self users do: [:each | Transcript show: 'Have to change ' , each name; cr.]! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/14/2013 14:49'!
isTraitTransformation
	"Polymorphic with TraitTransformation"
	^false! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/14/2013 16:26'!
notifyOfRecategorizedSelector: element from: oldCategory to: newCategory
	SystemChangeNotifier uniqueInstance selector: element recategorizedFrom: oldCategory to: newCategory inClass: self.

	"classify:under:from:trait: for all users"
	self users do: [:each | Transcript show: 'Have to change ' , each name; cr.]! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/14/2013 15:02'!
removeTraitUser: aTrait
	self users: (self users copyWithout: aTrait).
! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/14/2013 14:30'!
trait
	^self! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/14/2013 16:21'!
users

	^ ClassUsersMap at: (self name asSymbol) ifAbsentPut: [^ #()]! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/14/2013 16:20'!
users: aCollection

	Transcript show: aCollection asString.
	Transcript show: self asString.
	Transcript cr.
	^ ClassUsersMap at: (self name asSymbol) put: aCollection! !

Dictionary subclass: #ClassUsersMap
	instanceVariableNames: ''
	classVariableNames: 'ClassUsers'
	poolDictionaries: ''
	category: 'BrokenClasses'!

!ClassUsersMap class methodsFor: 'adding' stamp: 'lmn 1/14/2013 16:18'!
at: key ifAbsentPut: aBlock 
	ClassUsers ifNil: [ClassUsers := Dictionary new].
	^ (ClassUsers at: key ifAbsentPut: aBlock)! !

!ClassUsersMap class methodsFor: 'adding' stamp: 'lmn 1/14/2013 16:12'!
at: key put: aCollection
	ClassUsers ifNil: [ClassUsers := Dictionary new].
	^ ClassUsers at: key put: aCollection! !
